<?php declare(strict_types=1);

namespace Plugin\css_shipping\Migrations;

use JTL\Shop;
use JTL\Jtllog;


use JTL\Plugin\Migration;
use JTL\Update\IMigration;

/**
 * Class Migration20210429123301
 * @package Plugin\jtl_test\Migrations
 */
class Migration20210429123301 extends Migration implements IMigration {
	/**
	 * @inheritdoc
	 */


	public function columnExist($table, $field) {
		// false bedeutet das es die Spalte nicht gibt
		return $this->getDB()->query("Show columns from `" . $table . "` like '" . $field . "' ", 1);
	}

	public function tableExist($table) {
		// in Rows steht die Anzahl der Zeilen, false bedeutet das es die Tabelle nicht gibt
		$obj =  $this->getDB()->query("SHOW TABLE STATUS  like '" . $table . "'", 1);
		if($obj && (int) $obj->Rows == 0) {
			$o = $this->getDB()->query("SELECT COUNT(*) AS anzahl FROM " . $table . " WHERE 1",1);
			$obj->Rows = (int) $o->anzahl;
			return $obj;
		}
		return $obj;
	}


	public function copyTable($sourceDB, $destinationDB = "", $copyTable = true, $deleteSourceDB = false) {
		error_log('starte copy ' . $sourceDB);
		$result = $this->getDB()->query("SHOW TABLES LIKE '" . $sourceDB . "'", 2);
		if ($copyTable && $result !== null && is_array($result) && count($result)) {
			error_log('DB Vorhanden ' . $sourceDB);
			$result = $this->getDB()->query("SELECT * FROM " . $sourceDB . " WHERE 1", 2);
			foreach ($result as $oItem) {
				error_log('schreibe Datensatz nach ' . $destinationDB);
				$this->getDB()->insert($destinationDB, $oItem);
			}
		}
		if ($deleteSourceDB) {
			$this->execute("DROP TABLE IF EXISTS " . $sourceDB, 3);
		}
	}


	/*
	define('JTLLOG_LEVEL_EMERGENCY', 600);
	define('JTLLOG_LEVEL_ALERT', 550);
	define('JTLLOG_LEVEL_CRITICAL', 500);
	define('JTLLOG_LEVEL_ERROR', 400);
	define('JTLLOG_LEVEL_WARNING', 300);
	define('JTLLOG_LEVEL_NOTICE', 250);
	define('JTLLOG_LEVEL_INFO', 200);
	define('JTLLOG_LEVEL_DEBUG', 100);
*/



	public function up() {
		$this->execute("
              CREATE TABLE IF NOT EXISTS `css_shippingConfig` (
                  `version` varchar(10) NOT NULL DEFAULT '1.0.0',
                  `sqlupdate` int(10) NOT NULL DEFAULT '0',
                  `pluginActive` char(1) NOT NULL default 'N',
                  `framework` char(3) NOT NULL default 'B4',
                  `css` text NOT NULL,
                  `js` text NOT NULL,
                  `selector` varchar(255) NOT NULL DEFAULT '#content',
                  `selector_position` varchar(255) NOT NULL DEFAULT 'prepend',
								  `global_days` text NOT NULL,
								  `global_minimumQuantitySurcharge` decimal(6,2) DEFAULT 0.00,
								  `global_minimumOrderValue` decimal(6,2) DEFAULT 0.00,
                  `global_minimumQuantityVatSurcharge` int(10) NOT NULL DEFAULT '0',
								  `googleAPI` varchar(64) NOT NULL DEFAULT '',
								  `global_usePackage` char(1) NOT NULL DEFAULT 'N',
								  `volumen` varchar(250) NOT NULL DEFAULT ''
                ) ENGINE=InnoDB COLLATE utf8_unicode_ci
        ");

		$this->execute("
							CREATE TABLE IF NOT EXISTS `css_shippingOption` (
								  `id` int(10) NOT NULL AUTO_INCREMENT,
								  `kVersandart` int(10) NOT NULL DEFAULT 0,
								  `closedByDuration` varchar(1) NOT NULL DEFAULT 'N',
								  `closedByKupon` varchar(1) NOT NULL DEFAULT 'N',
								  `isActive` varchar(1) NOT NULL DEFAULT 'Y',
								  `overselling` varchar(1) NOT NULL DEFAULT 'N',
								  `markUpInPercent` decimal(6,2) DEFAULT 0.00,
								  `maxWidth` int(4) NOT NULL DEFAULT '0',
								  `maxHeight` int(4) NOT NULL DEFAULT '0',
								  `maxBroad` int(4) NOT NULL DEFAULT '0',
								  `maxWeight` int(5) NOT NULL DEFAULT '0',
								  `openDays` varchar(255) NOT NULL DEFAULT '',
								  `closedDays` text NOT NULL,
								  `closedTimeStart` varchar(10) NOT NULL DEFAULT '',
								  `closedTimeEnd` varchar(10) NOT NULL DEFAULT '',
								  `minimumQuantitySurcharge` decimal(6,2) DEFAULT 0.00,
								  `Mindermengenzuschlag` decimal(6,2) DEFAULT 0.00,
								  `mileageAllowance` decimal(6,2) DEFAULT 0.00,
								  `zipCode` varchar(5) NOT NULL DEFAULT '',
								  `country` varchar(2) NOT NULL DEFAULT 'DE',
								  `showInfo` char(1) NOT NULL DEFAULT 'N',
								  `usePackage` char(1) NOT NULL DEFAULT 'N',
								  `volumen` text NOT NULL,
		  					  PRIMARY KEY (`id`)
                ) ENGINE=InnoDB COLLATE utf8_unicode_ci
        ");

		if(($obj = $this->tableExist('css_gutscheinConfig')) && $obj->Rows > 0) {
			$this->execute("UPDATE css_shippingConfig set `version` = '2.0.0' ");
		} else {
			$this->execute(
				"INSERT INTO `css_shippingConfig` (`version`) VALUES ('2.0.0')"
			);
		}
	}

	/**
	 * @inheritdoc
	 */
	public function down() {
	}
}
