<?php declare(strict_types=1);

namespace Plugin\css_shipping\Migrations;

use JTL\Shop;
use JTL\Jtllog;


use JTL\Plugin\Migration;
use JTL\Update\IMigration;

/**
 * Class Migration20230427123301
 * @package Plugin\jtl_test\Migrations
 */
class Migration20230427123301 extends Migration implements IMigration {
	/**
	 * @inheritdoc
	 */


	public function columnExist($table, $field) {
		// false bedeutet das es die Spalte nicht gibt
		return $this->getDB()->query("Show columns from `" . $table . "` like '" . $field . "' ", 1);
	}

	public function tableExist($table) {
		// in Rows steht die Anzahl der Zeilen, false bedeutet das es die Tabelle nicht gibt
		$obj =  $this->getDB()->query("SHOW TABLE STATUS  like '" . $table . "'", 1);
		if($obj && (int) $obj->Rows == 0) {
			$o = $this->getDB()->query("SELECT COUNT(*) AS anzahl FROM " . $table . " WHERE 1",1);
			$obj->Rows = (int) $o->anzahl;
			return $obj;
		}
		return $obj;
	}



	public function up() {


		if($this->columnExist('css_shippingOption','markUpInPercent') === false) {
			$this->execute("ALTER TABLE `css_shippingOption` CHANGE `markUpInPercent` `markUpInPercent` TEXT NOT NULL");
		}

		if($this->columnExist('css_shippingOption','minWidth') === false) {
			$this->execute("ALTER TABLE `css_shippingOption`  ADD `minWidth` INT(4) NOT NULL DEFAULT '0'");
		}

		if($this->columnExist('css_shippingOption','minHeight') === false) {
			$this->execute("ALTER TABLE `css_shippingOption`  ADD `minHeight` INT(4) NOT NULL DEFAULT '0'");
		}

		if($this->columnExist('css_shippingOption','minBroad') === false) {
			$this->execute("ALTER TABLE `css_shippingOption` ADD `minBroad` INT(4) NOT NULL DEFAULT '0'");
		}

		if($this->columnExist('css_shippingOption','minWeight') === false) {
			$this->execute("ALTER TABLE `css_shippingOption` ADD `minWeight` INT(4) NOT NULL DEFAULT '0'");
		}

		if($this->columnExist('css_shippingOption','minMiles') === false) {
			$this->execute("ALTER TABLE `css_shippingOption` ADD `minMiles` INT(4) NOT NULL DEFAULT '0'");
		}

		if($this->columnExist('css_shippingOption','maxMiles') === false) {
			$this->execute("ALTER TABLE `css_shippingOption` ADD `maxMiles` INT(4) NOT NULL DEFAULT '0'");
		}

		if($this->columnExist('css_shippingOption','maximumQuantitySurcharge') === false) {
			$this->execute("ALTER TABLE `css_shippingOption` ADD `maximumQuantitySurcharge` DECIMAL(6, 2) NOT NULL DEFAULT '0.00'");
		}

		if($this->columnExist('css_shippingOption','minShippingPrice') === false) {
			$this->execute("ALTER TABLE `css_shippingOption` ADD `minShippingPrice` DECIMAL(6, 2) NOT NULL DEFAULT '0.00'");
		}

		if($this->columnExist('css_shippingConfig','paletteFunction') === false) {
			$this->execute("ALTER TABLE `css_shippingConfig` ADD `paletteFunction` CHAR(1) NOT NULL DEFAULT 'N'");
		}

		$this->execute("UPDATE css_shippingConfig set `version` = '2.0.2' ");
	}

	/**
	 * @inheritdoc
	 */
	public function down() {
	}
}
