<?php declare(strict_types=1);

namespace Plugin\css_shipping\Migrations;

use JTL\Shop;
use JTL\Jtllog;


use JTL\Plugin\Migration;
use JTL\Update\IMigration;

/**
 * Class Migration20230529123301
 * @package Plugin\jtl_test\Migrations
 */
class Migration20230529123301 extends Migration implements IMigration {
	/**
	 * @inheritdoc
	 */

	public function columnExist($table, $field) {
		// false bedeutet das es die Spalte nicht gibt
		return $this->getDB()->query("Show columns from `" . $table . "` like '" . $field . "' ", 1);
	}

	public function tableExist($table) {
		// in Rows steht die Anzahl der Zeilen, false bedeutet das es die Tabelle nicht gibt
		$obj =  $this->getDB()->query("SHOW TABLE STATUS  like '" . $table . "'", 1);
		if($obj && (int) $obj->Rows == 0) {
			$o = $this->getDB()->query("SELECT COUNT(*) AS anzahl FROM " . $table . " WHERE 1",1);
			$obj->Rows = (int) $o->anzahl;
			return $obj;
		}
		return $obj;
	}



	public function up() {

		if($this->columnExist('css_shippingOption','supplierWarehouse') === false) {
			$this->execute("ALTER TABLE css_shippingOption ADD `supplierWarehouse`  CHAR(1) NOT NULL DEFAULT 'N'");
		}

		$this->execute("UPDATE css_shippingConfig set `version` = '2.0.3' ");
	}

	/**
	 * @inheritdoc
	 */
	public function down() {
	}
}
