<?php declare(strict_types=1);

namespace Plugin\css_shipping\Migrations;

use JTL\Shop;
use JTL\Jtllog;


use JTL\Plugin\Migration;
use JTL\Update\IMigration;

/**
 * Class Migration20230826123301
 * @package Plugin\jtl_test\Migrations
 */
class Migration20230826123301 extends Migration implements IMigration {
	/**
	 * @inheritdoc
	 */

	public function columnExist($table, $field) {
		// false bedeutet das es die Spalte nicht gibt
		return $this->getDB()->query("Show columns from `" . $table . "` like '" . $field . "' ", 1);
	}

	public function tableExist($table) {
		// in Rows steht die Anzahl der Zeilen, false bedeutet das es die Tabelle nicht gibt
		$obj =  $this->getDB()->query("SHOW TABLE STATUS  like '" . $table . "'", 1);
		if($obj && (int) $obj->Rows == 0) {
			$o = $this->getDB()->query("SELECT COUNT(*) AS anzahl FROM " . $table . " WHERE 1",1);
			$obj->Rows = (int) $o->anzahl;
			return $obj;
		}
		return $obj;
	}


	public function up()    {

		if($this->columnExist('css_shippingOption','maxShippingPrice') === false) {
			$this->execute("ALTER TABLE `css_shippingOption` ADD `maxShippingPrice` DECIMAL(6,2) NOT NULL DEFAULT '0'");
		}

		if($this->columnExist('css_shippingOption','basicMilesPrice') === false) {
			$this->execute("ALTER TABLE `css_shippingOption` ADD `basicMilesPrice` DECIMAL(6,2) NOT NULL DEFAULT '0'");
		}

		if($this->columnExist('css_shippingOption','basicMiles') === false) {
			$this->execute("ALTER TABLE `css_shippingOption` ADD `basicMiles` INT(5) NOT NULL DEFAULT '0'");
		}

		if($this->columnExist('css_shippingOption','bulkPrice') === false) {
			$this->execute("ALTER TABLE `css_shippingOption` ADD `bulkPrice` TEXT NOT NULL ");
		}

		if(($obj = $this->tableExist('css_shippingConfig')) && $obj->Rows > 0) {
			$this->execute("UPDATE css_shippingConfig set `version` = '2.0.4' ");
		} else {
			$this->execute(
				"INSERT INTO `css_shippingConfig` (`version`) VALUES ('2.0.4')"
			);
		}

	}


	/**
	 * @inheritdoc
	 */
	public function down() {
	}
}
