<?php declare(strict_types=1);

namespace Plugin\css_shipping\Migrations;

use JTL\Shop;
use JTL\Jtllog;


use JTL\Plugin\Migration;
use JTL\Update\IMigration;

/**
 * Class Migration20240216123301
 * @package Plugin\jtl_test\Migrations
 */
class Migration20240216123301 extends Migration implements IMigration {
	/**
	 * @inheritdoc
	 */

	public function columnExist($table, $field) {
		// false bedeutet das es die Spalte nicht gibt
		return $this->getDB()->query("Show columns from `" . $table . "` like '" . $field . "' ", 1);
	}

	public function tableExist($table) {
		// in Rows steht die Anzahl der Zeilen, false bedeutet das es die Tabelle nicht gibt
		$obj =  $this->getDB()->query("SHOW TABLE STATUS  like '" . $table . "'", 1);
		if($obj && (int) $obj->Rows == 0) {
			$o = $this->getDB()->query("SELECT COUNT(*) AS anzahl FROM " . $table . " WHERE 1",1);
			$obj->Rows = (int) $o->anzahl;
			return $obj;
		}
		return $obj;
	}


	public function up()    {

		if(!$this->columnExist('css_shippingOption', 'checkConfigItems')) {
			$this->execute("ALTER TABLE `css_shippingOption` ADD `checkConfigItems` CHAR(1) NOT NULL DEFAULT 'Y' ");
		}
		if(!$this->columnExist('css_shippingOption', 'minForAll')) {
			$this->execute("ALTER TABLE `css_shippingOption` ADD `minForAll` CHAR(1) NOT NULL DEFAULT 'Y' ");
		}



		$cache = Shop::Container()->getCache();
		$cache->flush('css_shipping_shippingOption');

		if(($obj = $this->tableExist('css_shippingConfig')) && $obj->Rows > 0) {
			$this->execute("UPDATE css_shippingConfig set `version` = '2.0.8' ");
		} else {
			$this->execute(
				"INSERT INTO `css_shippingConfig` (`version`) VALUES ('2.0.8')"
			);
		}



	}




	/**
	 * @inheritdoc
	 */
	public function down() {
	}
}
